{*******************************************************}
{                                                       }
{       Advanced SQL statement parser                   }
{       Base class for testing complete SQL             }
{       statement parsing                               }
{       Copyright (c) 2001 - 2003 AS Gaiasoft           }
{       Created by Gert Kello                           }
{                                                       }
{*******************************************************}

unit gaAdvancedParserTestersBase;

interface

uses
  gaSQLParserTestersBase, gaBasicSQLParser, gaAdvancedSQLParser, TestFrameWork;

type
  TgaStatementTesterBase = class (TTestCase)
  private
    FParser: TgaAdvancedSQLParser;
    function GetStatement: TgaCustomSQLStatement;
  protected
    procedure ParseStatement(const SQLString: string);
    procedure SetUp; override;
    procedure TearDown; override;
    property Parser: TgaAdvancedSQLParser read FParser;
    property Statement: TgaCustomSQLStatement read GetStatement;
  end;
  
implementation

{
**************************** TgaStatementTesterBase ****************************
}
function TgaStatementTesterBase.GetStatement: TgaCustomSQLStatement;
begin
  Result := Parser.CurrentStatement;
end;

procedure TgaStatementTesterBase.ParseStatement(const SQLString: string);
begin
  Parser.SQLText.Text := SQLString;
  Parser.Reset;
  while not (Parser.TokenType = stEnd) do
    Parser.NextToken;
end;

procedure TgaStatementTesterBase.SetUp;
begin
  inherited;
  FParser := TgaAdvancedSQLParser.Create(nil);
end;

procedure TgaStatementTesterBase.TearDown;
begin
  FParser.Free;
  inherited;
end;

end.
