{*******************************************************}
{                                                       }
{       Advanced SQL statement parser                   }
{       Registering DUNit tests                         }
{       Copyright (c) 2001 - 2003 AS Gaiasoft           }
{       Created by Gert Kello                           }
{                                                       }
{*******************************************************}

unit gaSQLParserTestsReg;

interface

implementation

uses
  gaSQLFieldRefTests, gaSQLSelectFieldTests, gaSQLExpressionParserTests,
  gaSQLSelectStmTests, gaUserReportedBugTests, gaSelfFoundBugsTests,
  gaSQLOrderByTests,
  TestFrameWork;

function FieldParsingTests: ITestSuite;
begin
  Result := TTestSuite.Create('[Select] Field parsing tests');
  Result.AddSuite(TgaSQLFieldReferenceTester.Suite);
  Result.AddSuite(TgaSQLSelectFieldTester.Suite);
  Result.AddSuite(TgaSQLExpressionParserTester.Suite);
  Result.AddSuite(TgaSQLOrderByTester.Suite);
end;

function StatemtClassesTests: ITestSuite;
begin
  Result := TTestSuite.Create('Tests for SQL statement classes');
  Result.AddSuite(TgaSelectStmTester.Suite);
end;

function StatementParsingTests: ITestSuite;
begin
  Result := TTestSuite.Create('Tests for complete statement parsing');
  Result.AddSuite(TgaUserreportedBugTester.Suite);
  Result.AddSuite(TgaSelfFoundBugs.Suite);
end;

initialization
  RegisterTest(FieldParsingTests);
  RegisterTest(StatemtClassesTests);
  RegisterTest(StatementParsingTests);
end.
