{*******************************************************}
{                                                       }
{       Advanced SQL statement parser                   }
{       Classes for testing SQL expression parsing      }
{       Copyright (c) 2001 - 2003 AS Gaiasoft           }
{       Created by Gert Kello                           }
{                                                       }
{*******************************************************}

unit gaSQLSelectStmTests;

interface

uses
  gaSQLParserTestersBase, gaSelectStm, gaAdvancedSQLParser;

type
  TgaSelectStmTester = class (TgaSQLParserTesterBase)
  protected
    function CreateTestStatement: TgaCustomSQLStatement; override;
  published
    procedure TestSelectFieldAlias;
  end;
  

implementation

{
****************************** TgaSelectStmTester ******************************
}
function TgaSelectStmTester.CreateTestStatement: TgaCustomSQLStatement;
begin
  Result := TgaSelectSQLStatement.Create(nil);
end;

procedure TgaSelectStmTester.TestSelectFieldAlias;
begin
  AddStringToStatement('select mina.siin Minu, meie as Miski from', True);
  Check(Statement.AllFields.Count = 2, 'Field count for statement wrong');
  Statement.AllFields.First;
  Check(Statement.AllFields.CurrentItem.AsString = 'mina.siin Minu', 'first statement field wrong');
  Statement.AllFields.Next;
  Check(Statement.AllFields.CurrentItem.AsString = 'meie as Miski', 'second statement field wrong');
end;


end.
